; Przykadowe operacje arytmetyczne
; Rafa Baranowski (C) 2005

.INCLUDE "tn25def.inc"	; uwaga: wybrano ukad ATtiny25, poniewa
				;   ATtiny26 nie obsuguje instrukcji movx

	ldi	R16, low(RAMEND)
	out	SPL, R16
	ldi	R16, high(RAMEND)
	out	SPH, R16	; zainicjalizuj stos

; dodawanie (ustawiany znacznik H)
	ldi	R16, 15
	ldi	R17, 35
	add	R16, R17	; R16 = R16+R17

; dodawanie (ustawiane znaczniki S i N)
	ldi	R16, 10
	ldi	R17, 200
	add	R16, R17	; R16 = R16+R17

; dodawanie z przepenieniem (ustawiany znacznik C)
	ldi	R16, 200
	ldi	R17, 60
	add	R16, R17	; R16 = R16+R17

; przykad ptli iteracyjnej
	ldi	R16, 10
Petla_x10:
				; instrukcje znajdujce si tutaj zostan wykonane
	nop			;   10-krotnie (ich liczba jest ograniczona zakresem
	nop			;   skoku warunkowego, ktry umoliwia cofanie licznika
				;   programu maksymalnie o 63)
	dec	R16
	brne	Petla_x10

; dodawanie liczb ze znakiem
	ldi	R16, 10
	ldi	R17, -20	; R16 = R16+R17
	add	R16, R17

; dodawanie liczb ze znakiem, przepenienie U2
	ldi	R16, -10
	ldi	R17, -120
	add	R16, R17	; R16 = R16+R17

; dodawanie liczby bezporedniej
	ldi	R16, 5
	subi	R16, -10	; R16 = R16+10 (uwaga: C=1!)

; mnoenie liczb cakowitych (ze znakiem lub bez) przez 2
	ldi	R16, 10
	lsl	R16		; przesuwanie logiczne o jedn pozycj w lewo

; dzielenie liczb cakowitych bez znaku przez 2
	ldi	R16, 9
	lsr	R16		; przesuwanie logiczne o jedn pozycj w prawo

; dzielenie liczb cakowitych ze znakiem przez 2
	ldi	R16, -2
	asr	R16		; przesuwanie arytmetyczne o jedn pozycj w prawo

; mnoenie liczb cakowytych ze znakiem
	ldi	R16, 8
	ldi	R17, 32

	mov	mc8s, R16
	mov	mp8s, R17
	rcall	mpy8s
	mov	R16, m8sL
	mov	R17, m8sH	; R17:16 = R16*R17

; przykadowe operacje na liczbach 16-bitowych
	movw	R25:R24, R1:R0
	adiw	R25:R24, 10
	movw	R1:R0, R25:R24

; mnoenie liczb uamkowych ze znakiem
	ldi	R16, q7(-0.125)
	ldi	R17, q7(0.5)

	mov	mc8s, R16
	mov	mp8s, R17
	rcall	mpy8s
	mov	R16, m8sL
	mov	R17, m8sH
	lsl	R16
	rol	R17

; mnoenie liczby cakowitej przez liczb uamkow
	ldi	R16, 100
	ldi	R17, q7(0.25)

	mov	mc8s, R16
	mov	mp8s, R17
	rcall	mpy8s
	mov	R16, m8sL
	mov	R17, m8sH
	lsl	R16
	rol	R17

; przykad maskowania rejestru
	ldi	R17, 0x0F
	and	R16, R17

; przykad znajdywania rnic pomidzy wartociami
	ldi	R16, 0b10110101
	ldi	R17, 0b11011100
	eor	R16, R17

Petla:
	rjmp Petla		; ptla nieskoczona



; podprogram "mpy8s" - mnoenie liczb 8-bitowych ze znakiem (U2) 

				; deklaracje wykorzystywanych rejestrw
.def	mc8s	 = R20	;   rejestr mnonej
.def	mp8s	 = R21	;   rejestr mnonika
.def	m8sL	 = R21	;   rejestr LSB wyniku
.def	m8sH	 = R22	;   rejestr MSB wyniku
.def	mcnt8s = R23	;   rejestr pomocniczy

mpy8s:
	sub	m8sH, m8sH
	ldi	mcnt8s, 8
m8s_1:
	brcc	m8s_2
	add	m8sH, mc8s
m8s_2:
	sbrc	mp8s,0
	sub	m8sH, mc8s
	asr	m8sH
	ror	m8sL
	dec	mcnt8s
	brne	m8s_1
	ret
