; PODPROGRAMY UATWIAJCE OBSUG WEWNTRZNEJ PAMICI EEPROM
; Rafa Baranowski (C) 2005
;
; Etykiety procedur:
; 	Zapisz_EE		- zapis bajtu w pamici EEPROM
;	Czytaj_EE		- odczyt bajtu z pamici EEPROM
;


;****************************************************************
;	PROCEDURA ZAPISUJCA BAJT W PAMICI EEPROM
;
; Parametry:
;	R17	- adres modyfikowanej komrki pamici EEPROM
;	R16	- warto zapisywana w pamici
;
; Uwagi:
;	- procedura automatycznie wcza zezwolenie na przerwania (I=1)
;
Zapisz_EE:
	push	R18
Zap_EE_1:
	in	R18, EECR	
	sbrc	R18, EEWE	; oczekiwanie na zakoczenie ewentualnego
	rjmp	Zap_EE_1	;   procesu zapisu pamici

	out	EEAR, R17	; okrel adres zapisywanej komrki
	out	EEDR, R16	; okrel warto do zapisu

	ldi	R18, 1<<EEMWE
	cli			; blokuj przerwania na czas sekwencji zapisu
	out	EECR, R18	; wcz tymczasowe zezwolenie na zapis
	ldi	R18, 1<<EEWE
	out	EECR, R18	; przeprowad zapis
	sei			; odblokuj przerwania

	pop	R18
	ret


;****************************************************************
;	PROCEDURA ODCZYTUJCA BAJT Z PAMICI EEPROM
;
; Parametry:
;	R17	- adres odczytywanej komrki pamici EEPROM
;
; Wartoci wyjciowe:
;	R16	- warto odczytana z pamici
;
Czytaj_EE:
	in	R16, EECR
	sbrc	R16, EEWE	; oczekiwanie na zakoczenie ewentualnego
	rjmp	Czytaj_EE	;   procesu zapisu pamici

	out	EEAR, R17	; okrel adres odczytywanej komrki

	ldi	R16, 1<<EERE
	out	EECR, R16	; odczytaj pami EEPROM
	in	R16, EEDR	; i umie wynik w rejestrze R16

	ret
